/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *  Copyright (C) 2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: prc_insn.h 1 2010-06-14 02:33:52Z ertl-ichiba $
 */

/*
 *  ץåü̿Υ饤ؿNios2ѡ
 */

#ifndef TOPPERS_PRC_INSN_H
#define TOPPERS_PRC_INSN_H

/*
 *  status쥸Ƥ
 */
Inline uint32_t
current_status(void)
{
	uint32_t status;
	Asm("rdctl %0, status" : "=r" (status));
	return(status);
}

/*
 *  status쥸Ƥ
 */
Inline void
set_status(uint32_t status)
{
	Asm("wrctl status, %0" :: "r" (status));
}

/*
 *  esatus쥸Ƥ
 */
Inline uint32_t
current_estatus(void)
{
	uint32_t status;
	Asm("rdctl %0, estatus" : "=r" (status));
	return(status);
}

/*
 *  bsatus쥸Ƥ
 */
Inline uint32_t
current_bstatus(void)
{
	uint32_t status;
	Asm("rdctl %0, bstatus" : "=r" (status));
	return(status);
}

/*
 *  ipending쥸Ƥ
 */
Inline uint32_t
current_ipending(void)
{
	uint32_t status;
	Asm("rdctl %0, ipending" : "=r" (status));
	return(status);
}

/*
 *  ienable쥸Ƥ
 */
Inline uint32_t
current_ienable(void)
{
    uint32_t status;
    Asm("rdctl %0, ienable" : "=r" (status));
    return(status);
}

/*
 *  ienable쥸
 */
Inline void
set_ienable(uint32_t ienable)
{
	Asm("wrctl ienable, %0" :: "r" (ienable));
}

#endif /* TOPPERS_PRC_INSN_H */
